!
function(win, lib) {
    function compareVersion(a, b) {
        a = a.toString().split("."),
        b = b.toString().split(".");
        for (var c = 0; c < a.length || c < b.length; c++) {
            var d = parseInt(a[c], 10),
            e = parseInt(b[c], 10);
            if (window.isNaN(d) && (d = 0), window.isNaN(e) && (e = 0), e > d) return - 1;
            if (d > e) return 1
        }
        return 0
    }
    function callback(a, b) {
        isAndroid && compareVersion(osVersion, "2.4.0") < 0 ? setTimeout(function() {
            a && a(b)
        },
        1) : a && a(b)
    }
    var doc = win.document,
    ua = win.navigator.userAgent,
    isIOS = /iPhone|iPad|iPod/i.test(ua),
    isAndroid = /Android/i.test(ua),
    osVersion = ua.match(/(?:OS|Android)[\/\s](\d+[._]\d+(?:[._]\d+)?)/i),
    wvVersion = ua.match(/WindVane[\/\s](\d+[._]\d+[._]\d+)/),
    hasOwnProperty = Object.prototype.hasOwnProperty,
    WindVane = lib.windvane = win.WindVane || (win.WindVane = {}),
    WindVane_Native = win.WindVane_Native,
    callbackMap = {},
    inc = 1,
    iframePool = [],
    iframeLimit = 3,
    LOCAL_PROTOCOL = "hybrid",
    WV_PROTOCOL = "wv_hybrid",
    IFRAME_PREFIX = "iframe_",
    SUCCESS_PREFIX = "suc_",
    FAILURE_PREFIX = "err_",
    DEFERRED_PREFIX = "defer_",
    PARAM_PREFIX = "param_";
    osVersion = osVersion ? (osVersion[1] || "0.0.0").replace(/\_/g, ".") : "0.0.0",
    wvVersion = wvVersion ? (wvVersion[1] || "0.0.0").replace(/\_/g, ".") : "0.0.0";
    var WV_Core = {
        call: function(a, b, c, d, e, f) {
            var g, h;
            return "number" == typeof arguments[arguments.length - 1] && (f = arguments[arguments.length - 1]),
            "function" != typeof d && (d = null),
            "function" != typeof e && (e = null),
            lib.promise && (h = lib.promise.deferred()),
            g = f > 0 ? setTimeout(function() {
                WV_Core.onFailure(g, {
                    ret: "TIMEOUT"
                })
            },
            f) : WV_Private.getSid(),
            WV_Private.registerCall(g, d, e, h),
            isAndroid ? compareVersion(wvVersion, "2.7.0") >= 0 ? WV_Private.callMethodByPrompt(a, b, WV_Private.buildParam(c), g + "") : WindVane_Native && WindVane_Native.callMethod && WindVane_Native.callMethod(a, b, WV_Private.buildParam(c), g + "") : isIOS && WV_Private.callMethodByIframe(a, b, WV_Private.buildParam(c), g + ""),
            h ? h.promise() : void 0
        },
        fireEvent: function(a, b) {
        	console.log("fireEvent in windvane.js");
            var c = doc.createEvent("HTMLEvents");
            c.initEvent(a, !1, !0),
            c.param = WV_Private.parseParam(b),
            doc.dispatchEvent(c)
        },
        getParam: function(a) {
            return WV_Private.params[PARAM_PREFIX + a] || ""
        },
        onSuccess: function(a, b) {
            clearTimeout(a);
            var c = WV_Private.unregisterCall(a),
            d = c.success,
            e = c.deferred,
            f = WV_Private.parseParam(b);
            callback(function(a) {
                d && d(a),
                e && e.resolve(a)
            },
            f.value || f),
            WV_Private.onComplete(a)
        },
        onFailure: function(a, b) {
            clearTimeout(a);
            var c = WV_Private.unregisterCall(a),
            d = c.failure,
            e = c.deferred,
            f = WV_Private.parseParam(b);
            callback(function(a) {
                d && d(a),
                e && e.reject(a)
            },
            f),
            WV_Private.onComplete(a)
        }
    },
    WV_Private = {
        params: {},
        buildParam: function(a) {
            return a && "object" == typeof a ? JSON.stringify(a) : a || ""
        },
        parseParam: function(str) {
            var rst;
            if (str && "string" == typeof str) try {
                rst = JSON.parse(str)
            } catch(e) {
                rst = eval("(" + str + ")")
            } else rst = str || {};
            return rst
        },
        getSid: function() {
            return Math.floor(Math.random() * (1 << 50)) + "" + inc++
        },
        registerCall: function(a, b, c, d) {
            b && (callbackMap[SUCCESS_PREFIX + a] = b),
            c && (callbackMap[FAILURE_PREFIX + a] = c),
            d && (callbackMap[DEFERRED_PREFIX + a] = d)
        },
        unregisterCall: function(a) {
            var b = SUCCESS_PREFIX + a,
            c = FAILURE_PREFIX + a,
            d = DEFERRED_PREFIX + a,
            e = {
                success: callbackMap[b],
                failure: callbackMap[c],
                deferred: callbackMap[d]
            };
            return delete callbackMap[b],
            delete callbackMap[c],
            e.deferred && delete callbackMap[d],
            e
        },
        useIframe: function(a, b) {
            var c = IFRAME_PREFIX + a,
            d = iframePool.pop();
            d || (d = doc.createElement("iframe"), d.setAttribute("frameborder", "0"), d.style.cssText = "width:0;height:0;border:0;display:none;"),
            d.setAttribute("id", c),
            d.setAttribute("src", b),
            d.parentNode || setTimeout(function() {
                doc.body.appendChild(d)
            },
            5)
        },
        retrieveIframe: function(a) {
            var b = IFRAME_PREFIX + a,
            c = doc.querySelector("#" + b);
            iframePool.length >= iframeLimit ? doc.body.removeChild(c) : iframePool.push(c)
        },
        callMethodByIframe: function(a, b, c, d) {
            var e = LOCAL_PROTOCOL + "://" + a + ":" + d + "/" + b + "?" + c;
            this.params[PARAM_PREFIX + d] = c,
            this.useIframe(d, e)
        },
        callMethodByPrompt: function(a, b, c, d) {
            var e = LOCAL_PROTOCOL + "://" + a + ":" + d + "/" + b + "?" + c,
            f = WV_PROTOCOL + ":";
            this.params[PARAM_PREFIX + d] = c,
            window.prompt(e, f)
        },
        onComplete: function(a) {
            isIOS && this.retrieveIframe(a),
            delete this.params[PARAM_PREFIX + a]
        }
    };
    for (var key in WV_Core) hasOwnProperty.call(WindVane, key) || (WindVane[key] = WV_Core[key])
} (window, window.lib || (window.lib = {}));